DAT objectName          byte "HeaderVexTreads131212a", 0
robotName               byte "VexTreads", 0
  
CON
{{
  ******* Public Notes *******
  
}}
{
  ******* Private Notes *******

  HeaderVexTreads130130a modified DemoFourMotorsAndEncoders130130a
  130130a Move individual robot constants to a header file
  to make it easy to use the same code with multiple robots.
  130201a Set some unused pins to "-1".
  07a Motor #0 move robot in reverse with positive speed.
  Motor #1 move robot forward with positive speed.
  1208a Modify to match changes made when servo used.
  
}   

  '' The "RED" constants don't have to be assigned to
  '' red wires. It may be useful to switch the pin
  '' assignments if the wheel direction doesn't match
  '' the encoder directions.
  '' Set FIRST_ENCODER_x to "-1" if a encoder isn't being used.
  '' Set WHEEL_ENABLE_x to "-1" if a motor isn't being used.
  '' If WHEEL_RED_x is set to -1 and the enable pin is set
  '' to a valid I/O pin, the motor will be treated as a
  '' hobby servo.
  '' If WHEEL_RED_x is a valid I/O pin but WHEEL_BLACK_x
  '' is set to -1, then the motor will be treated as
  '' being controlled by a h-bridge with a single direction
  '' control pin. Dynamic braking will not be possible
  '' in this case.

  WHEEL_RED_0 = 10 '9
  WHEEL_BLACK_0 = 9 '10
  WHEEL_RED_1 = 12
  WHEEL_BLACK_1 = 13
  WHEEL_RED_2 = -1 '15 
  WHEEL_BLACK_2 = -1 '16
  WHEEL_RED_3 = -1 '18
  WHEEL_BLACK_3 = -1 '19
  
  WHEEL_ENABLE_0 = 8 
  WHEEL_ENABLE_1 = 11 
  WHEEL_ENABLE_2 = -1 '14 
  WHEEL_ENABLE_3 = -1 '17
  
  FIRST_ENCODER_0 = 0
  FIRST_ENCODER_1 = 2
  FIRST_ENCODER_2 = 4
  FIRST_ENCODER_3 = 6

  {RADIO_PIN = 10        ' The program expects six sequencial pins connected to a
                        ' rc receiver. If fewer than six pins are used the
                        ' "BotControl" object will need to be modified (not hard).
                        ' If anyone needs fewer than six pins let me know and I'll
                        ' make the needed changes.
                        ' The "RADIO_PIN" is used the set the values of the 
                        ' "controllerPin" array in the DAT section.
                        
  NORDIC_BASE_PIN = 10
  NODIC_IRQ_PIN = 22 'NORDIC_BASE_PIN + 0
  NORDIC_MISO_PIN = DI_ADC 'NORDIC_BASE_PIN + 1                     
  NODIC_MOSI_PIN = DO_ADC 'NORDIC_BASE_PIN + 2
  NODIC_SCK_PIN = CLK_ADC 'NORDIC_BASE_PIN + 3
  NODIC_SCN_PIN = 23 'NORDIC_BASE_PIN + 4
  NODIC_CE_PIN = 19 'NORDIC_BASE_PIN + 5
  
  DO_SD = 27 'aka DAT0                 ' SD card pin assignments.
  CLK_SD = 28
  DI_SD = 26 'aka CMD
  CS_SD = 25 'aka DAT3
  WP_SD = -1
  CD_SC = -1

  CS_ADC = 24
  DI_ADC = 26
  DO_ADC = 27
  CLK_ADC = 28
  
  I2C_CLOCK = 28
  I2C_DATA = 29

  FEEDBACK_MOTOR0 = 0
  FEEDBACK_MOTOR1 = 1    }
  
  FORWARD0 = 1
  FORWARD1 = 1
  FORWARD2 = 1
  FORWARD3 = 1
 ' FULL_SPEED = 940 '28 '69       ' Measured with PROPORTIONAL_CONSTANT set to zero and
                        ' target speeds set to max allowed (usually 1000).
  '4331 transitions per revolution
  'Gears in Pololu motor: 10:25,10:30,12:28,10:40
  ' reduction = 25/10 * 30/10 * 28/12 * 40/10 = 5/2 * 3 * 7/3 * 4 = 5*7*2 = 70
  ' 70 * 64 = 4,480 transitions per revolution
  MAX_TRANSITIONS_PER_SEC = 10827 '282
             
  'FULL_SPEED_TIMED = 6900  ' not measured                    


  'FULL_SPEED = 28 '69       ' Measured with PROPORTIONAL_CONSTANT set to zero and
                        ' target speeds set to max allowed (usually 1000)
  'MAX_TRANSITIONS_PER_SEC = 500 ' Dagu Rover 5 
  ' 1000 transitions per three rotations  1.5 rev per second

  TRANS_PER_REV_NUMERATOR = 4480 ' Pololu 70:1 gearmotors (listed as 67:1) 
  TRANS_PER_REV_DENOMINATOR = 1 ' In case transitions per rev isn't a whole number         
  'TRANS_PER_REV_NUMERATOR = 1000 ' Dagu Rover 5 
  'TRANS_PER_REV_DENOMINATOR = 3 ' Dagu Rover 5      

  DIAMETER_OF_WHEEL = 66 ' ActivityBot wheel in mm
 ' PSEUDO_RADIUS_OF_WHEEL = (DIAMETER_OF_WHEEL * PSEUDOREAL_MULTIPLIER) / 2                     
  'FULL_SPEED_TIMED = 690                      
  PSEUDOREAL_MULTIPLIER = 100 ' If the multiplier is too large values used in calculations
                              ' could exceed 32-bits.

 
  'PSEUDO_FULL_SPEED = FULL_SPEED * PSEUDOREAL_MULTIPLIER
  DEFAULT_ACCELERATION = 10
  PSEUDO_ACCELERATION = DEFAULT_ACCELERATION * PSEUDOREAL_MULTIPLIER
  REFRESH_RATE = 50 '20 '
  {
  PID_INCREASE = 10
  PID_MULTIPLIER = PSEUDOREAL_MULTIPLIER * PID_INCREASE
  PSEUDO_DT = 75
  PROPORTIONAL_CONSTANT = 24 '5
  INTEGRAL_CONSTANT = 0
  MAX_INTEGRAL = 12000 '2000
  DERIVATIVE_CONSTANT = 0
  STEPS_PER_FIGURE_8 = 1150
  INPUT_SIGNIFICANT = 20    ' used to detect when landing gear switch as been thrown
  
  ' wheelMode enumeration
  #0, INDEPENDENT_WHEELS, TREADED_WHEELS, MECANUM_WHEELS 

  'WHEEL_MODE = INDEPENDENT_WHEELS '' Use this when first setting up robot
  'WHEEL_MODE = TREADED_WHEELS     '' The target speeds of each side will be matched.
  WHEEL_MODE = MECANUM_WHEELS    
  
  ' inputType enumeration
  #0, PC_ONLY_INPUT, WII_NUNCHUCK_INPUT, RC_INPUT, WII_AND_RC_INPUT, AUTO_DETECT_INPUT

  'INPUT_TYPE = PC_ONLY_INPUT       '' Use this when first setting up robot
  'INPUT_TYPE = WII_NUNCHUCK_INPUT   
  'INPUT_TYPE = RC_INPUT
  'INPUT_TYPE = WII_AND_RC_INPUT    '' Not yet supported. If used it will behave the same
                                    '' as AUTO_DETECT_INPUT.                                                                                                                                            
  INPUT_TYPE = AUTO_DETECT_INPUT   '' Priority given to Nunchuck
  
  DEFAULT_SPEED = 150 '450 '600    ' Used in figure 8 not presently calibrated
                              
  DEFAULT_TURN_RATE = 100 '25 'DEFAULT_SPEED / 2 '4  ' Used in figure 8, the larger the turn rate 
                                            ' the larger the loops of the figure 8 will
                                            ' be.
                                            
  ' inputType enumeration 
  #0, NO_COMPASS, HMC5883_COMPASS, AUTO_DETECT_COMPASS
  
  COMPASS_MODE = HMC5883_COMPASS

  ' phaseOf8 enumeration 
  #0, START_1ST_LOOP, WATCH_FOR_END_1ST_LOOP, EXTEND_1ST_LOOP, {
  } START_2ND_LOOP, WATCH_FOR_END_2ND_LOOP, EXTEND_2ND_LOOP, FINISHED_LOOP
                                              
  ' stepsOf8 
  START_1ST_STEPS = REFRESH_RATE * 2 'STEPS_PER_FIGURE_8 / 8 ' quarter circle
  WATCH_FOR_END_1ST_STEPS = 10000'(STEPS_PER_FIGURE_8 / 2) - START_1ST_STEPS'START_1ST_STEPS * 3
  EXTEND_1ST_STEPS = STEPS_PER_FIGURE_8 / 4
  START_2ND_STEPS = START_1ST_STEPS
  WATCH_FOR_END_2ND_STEPS = WATCH_FOR_END_1ST_STEPS
  EXTEND_2ND_STEPS = EXTEND_1ST_STEPS
  WAIT_FOR_8_TIME = REFRESH_RATE * 4 ' four seconds
  

  MIN_STEPS = STEPS_PER_FIGURE_8
  MAX_STEPS = STEPS_PER_FIGURE_8 * 100
                           
  #0, COUNTER_CLOCKWISE_TURN, CLOCKWISE_TURN
                            
  FIRST_LOOP_TURN_DIRECTION = COUNTER_CLOCKWISE_TURN

  ' slaveMode enumeration
  #0, MASTER, SLAVE 

  DEFAULT_SLAVE_MODE = MASTER

  ' encoderMode enumeration
  #0, COUNT_TICKS_SPEED, TIME_TICKS_SPEED, HYBRID_SPEED 

  DEFAULT_ENCODER_MODE = COUNT_TICKS_SPEED

  ' startAction enumeration
  #0, WAIT_FOR_INPUT_START, FIGURE_8_START, AUTONOMOUS_WANDER_START
  
  DEFAULT_START = WAIT_FOR_INPUT_START

  ' radio type enumeration
  #0, RC_RADIO, NORDIC_NRF24L01P_RADIO, NORDIC_NRF2401A_RADIO

  DEFAULT_RADIO = NORDIC_NRF24L01P_RADIO

  ' pin offsets
  #0, IRQ_PIN_OFFSET, MISO_PIN_OFFSET, MOSI_PIN_OFFSET, SCK_PIN_OFFSET, SCN_PIN_OFFSET, CE_PIN_OFFSET
  }
PUB GetObjectName

  result := @objectName

PUB GetRobotName

  result := @robotName

{PUB GetControllerPins

  case DEFAULT_RADIO
    RC_RADIO:
      result := @controllerPin
    NORDIC_NRF24L01P_RADIO:
      result := @nordicPin
}     
PUB GetEncoderPins

  result := @encoderPin
  
PUB GetEnablePins

  result := @enablePin
  
PUB GetRedPins

  result := @redPin
  
PUB GetBlackPins

  result := @blackPin
  
{PUB GetPidParameters

  result := @pidParameters
  
PUB PathData

  result := @autonomous
}  
{DAT

controllerPin byte RADIO_PIN, RADIO_PIN + 1, RADIO_PIN + 2, RADIO_PIN + 3
              byte RADIO_PIN + 4, RADIO_PIN + 5
              
DAT

nordicPin     byte NODIC_IRQ_PIN, NORDIC_MISO_PIN, NODIC_MOSI_PIN
              byte NODIC_SCK_PIN, NODIC_SCN_PIN, NODIC_CE_PIN
}
DAT

encoderPin    byte FIRST_ENCODER_0, FIRST_ENCODER_1, FIRST_ENCODER_2, FIRST_ENCODER_3
                          
DAT

enablePin     long WHEEL_ENABLE_0, WHEEL_ENABLE_1, WHEEL_ENABLE_2, WHEEL_ENABLE_3

DAT

redPin        long WHEEL_RED_0, WHEEL_RED_1, WHEEL_RED_2, WHEEL_RED_3

DAT

blackPin      long WHEEL_BLACK_0, WHEEL_BLACK_1, WHEEL_BLACK_2, WHEEL_BLACK_3
                          
{DAT
      
pidParameters long PROPORTIONAL_CONSTANT, INTEGRAL_CONSTANT, DERIVATIVE_CONSTANT, PID_INCREASE
              long MAX_INTEGRAL
              
DAT
     
autonomous    long DEFAULT_SPEED
}